<?php
/************************************************************************
 * This file is part of EspoCRM.
 *
 * EspoCRM - Open Source CRM application.
 * Copyright (C) 2014  Yuri Kuznetsov, Taras Machyshyn, Oleksiy Avramenko
 * Website: http://www.espocrm.com
 *
 * EspoCRM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * EspoCRM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EspoCRM. If not, see http://www.gnu.org/licenses/.
 ************************************************************************/

class AfterUpgrade
{
    public function run($container)
    {
        $config = $container->get('config');

        $config->set('calendarEntityList', ['Meeting', 'Call', 'Task']);
        $config->save();

        $pdo = $container->get('entityManager')->getPDO();

        $sql = "
            UPDATE email_filter
            SET is_global = 1
            WHERE
            parent_id IS NULL
        ";
        $pdo->query($sql);

        $sql = "
            SET @order := 9999;
            UPDATE knowledge_base_article SET `order` = (@order := @order + 1) ORDER BY name;
        ";
        $pdo->exec($sql);

        $entityManager = $container->get('entityManager');

        if (!$entityManager->getRepository('ScheduledJob')->where(array(
            'job' => 'SendEmailNotifications'
        ))->findOne()) {
            $job = $entityManager->getEntity('ScheduledJob');
            $job->set(array(
                'name' => 'Send Email Notifications',
                'job' => 'SendEmailNotifications',
                'scheduling' => '/2 * * * *',
                'status' => 'Active'
            ));
            $entityManager->saveEntity($job);
        }
    }
}
